<template>
  <div class="row">
    <!-- leftbox -->
    <div class="result col-sm-12" />
    <!-- input file -->
    <div class="col-sm-12">
      <!-- download btn -->
      <click-button
        v-if="imageUrl.length!==0"
        @click="sendCroppedLogo"
      >
        <template slot="content">
          Envoyer le logo redimensionné
        </template>
      </click-button>
    </div>
  </div>
</template>
<script>
import Cropper from 'cropperjs'
import VanillaToasts from "vanillatoasts"
import {mapActions} from "vuex";
import ClickButton from "../Button/ClickButton";
export default {
  name: "CropImage",
  components: {ClickButton},
  props: {
    imageUrl: {
      type: String,
      default: ''
    },
    file: {
      type: Object,
      default: null
    },
  },
  data() {
    return {
      cropper: '',
      finalCropWidth: 110,
      finalCropHeight: 42,
      result: null
    }
  },
  watch: {
    imageUrl: function (newVal) {
      const finalAspectRatio = this.finalCropWidth / this.finalCropHeight;

      // create new image
      let img = document.createElement('img');
      img.id = 'image';
      img.src = newVal
      this.result=document.querySelector('.result')
      // clean result before
      this.result.innerHTML = '';
      // append new image
      this.result.appendChild(img);
      // init cropper
      this.cropper = new Cropper(img, {
        aspectRatio: finalAspectRatio
      });
    }
  },
  methods: {
    ...mapActions([
      'sendLogo',
      'loadingStarts',
      'loadingEnds'
    ]),
    uploadLogo(blob) {
      const file = new File([blob], 'custom-logo.png', {type: blob.type});
      if (file.size > 3000000) {
        VanillaToasts.create({
          title: 'Transmission de logo',
          text: 'Taille limite atteinte 3 Mo',
          type: 'error',
          timeout: 5000,
        });
      }
      let formData = new FormData();
      this.loadingStarts()
      formData.append('files[0]', file)
      this.sendLogo(formData)
        .then(() => {
          if (!this.logoHasError) {
            VanillaToasts.create({
              title: 'Transmission de logo',
              text: 'Opération effectuée avec succès',
              type: 'success',
              timeout: 10000,
            });
          }
          this.loadingEnds()
        })
        .catch(() => {
          this.loadingEnds()
        })
        .finally(()=> {
          this.$emit('logoUpdated')
          this.result.innerHTML = ''
        })
    },
    sendCroppedLogo() {
      this.cropper.getCroppedCanvas({
        width: this.finalCropWidth,
        height: this.finalCropHeight
      }).toBlob(blob => this.uploadLogo(blob))
    }
  }
}
</script>

<style scoped>
  .result {
    max-height: 400px;
    margin-bottom: 1em;
  }
</style>